# GroupLineUpA. http://www.est.hi-ho.ne.jp/atamadekkati/ 
# 그룹화,컴포넌트화되어진 재를일렬로나열한다。
# 2009/07/19 ver1.00 작성
# 2009/08/02 ver1.10 사이즈(치수)는회전전에삭제하는것으로한다。
# 2009/08/16 ver1.50 이렉터조인트(ir#)의컴포넌트는,특수처리한다。
# 2009/09/18 ver1.60 기재하는명칭을그룹명이나레이어명등으로선택할수있도록한다。
#
# 책임은 사용자 스스로...。
# hongmidi@naver.com hongmidi(홍사철) 한글화편집 2013/06/03。
#

require 'sketchup.rb'

#============= 메인프로그램 =============
def ozlineup
  model = Sketchup.active_model
  entities = model.entities
  bbox = model.bounds

# 초기설정
  @yadd = 20.mm                    #부재간 거리 초기치
  textarrowlen = 1                 #Text작성시 끌어내기선 몇배로 확대할것인가。
  textarrowvec = [ -1 , 0 , 0 ]    #Text작성시 위치기준 백터(그룹명)
  textarrowvecsize = [ 1 , 0 , 0 ]    #Text작성시 위치기준 (그룹사이즈)

# prompts
  prompts=["부재간 거리", "Text표시","부재회전"]
  values=[@yadd, "레이어명", "회전"]
  enums=[nil, "그룹명|레이어명|비표시", "회전|그대로"]
  results=inputbox prompts, values, enums, "그룹마다 흐트러짐。사전보관필수。"
  return if not results
  @yadd=results[0]
  textarrowlen = @yadd * textarrowlen
  @textarrowvector = [textarrowvec[0] * textarrowlen , textarrowvec[1] * textarrowlen , textarrowvec[2] * textarrowlen ]
  @textarrowvectorsize = [textarrowvecsize[0] * textarrowlen , textarrowvecsize[1] * textarrowlen , textarrowvecsize[2] * textarrowlen ]
  if results[1] == "그룹명" then
    textnamesw=1 
  elsif results[1] == "레이어명" then
    textnamesw=2 
  else
  	textnamesw=0
  end
  if results[2] == "회전" then
    rotatesw=1 
  elsif results[2] == "그대로" then
  	rotatesw=0
  else    # 사용하지않음。
    rotatesw=2
    mboxresult = UI.messagebox "그룹작성시 사이즈 방향으로 되돌립니다。좋습니까?。", MB_OKCANCEL
    return if mboxresult == 2
  end

  Sketchup::set_status_text("group 1 line, please wait...", SB_PROMPT) 
  Sketchup.active_model.start_operation("부재나열")

# 모델내 수 카운트、삭제대상(사이즈)점검
  nr_edges = nr_faces = nr_componentinstances = nr_groups = nr_images = nr_sectionplanes = nr_dimensions = nr_texts = nr_clines = nr_cpoints = 0
  deleteents = []
  entities.each {|ent|
    type = ent.typename
    case type
      when "Edge"
        nr_edges = nr_edges + 1
      when "Face"
        nr_faces = nr_faces + 1
      when "ComponentInstance"
        nr_componentinstances = nr_componentinstances + 1
      when "Group"
        nr_groups = nr_groups + 1
      when "Image"
        nr_images = nr_images + 1
      when "SectionPlane"
        nr_sectionplanes = nr_sectionplanes + 1
      when "DimensionLinear" 
        nr_dimensions = nr_dimensions + 1
        deleteents.push ent
      when "DimensionRadial" 
        nr_dimensions = nr_dimensions + 1
        deleteents.push ent
      when "Text"
        nr_texts = nr_texts + 1
      when "ConstructionLine"
        nr_clines = nr_clines + 1
      when "ConstructionPoint"
        nr_cpoints = nr_cpoints + 1
    end
  }

# 삭제대상(수치)삭제
	entities.erase_entities deleteents

# 그룹과 컴퍼넌트 회전
  irectorents = []
	yzahyo = nilname = 0
  entities.each {|e|
    type = e.typename
    case type
      when "ComponentInstance"
        if e.definition.name[0,3] == "ir#" then
          irectorents.push e
        else
          if rotatesw != 0 then
#                if rotatesw == 2 then
            rotateorigin( e )
#                end
            rotate90( e )
          end
          transpt = Geom::Point3d.new 0, yzahyo, 0
          enttrans( e , transpt )
          if textnamesw != 0 then
            textwrite( e , entities , textnamesw )
          end
          yzahyo = e.bounds.max.y + @yadd
        end
      when "Group"
        if rotatesw != 0 then
#          if rotatesw == 2 then
          rotateorigin( e )
#          end
          rotate90( e )
        end
        transpt = Geom::Point3d.new 0, yzahyo, 0
        enttrans( e , transpt )
        if textnamesw != 0 then
          textwrite( e , entities , textnamesw )
        end
        yzahyo = e.bounds.max.y + @yadd
    end
  }

# (ir#)컴퍼넌트는 회전하지 않고 같은 종류의 컴퍼넌트단위로 나열한다
# 　단, 회전하지 않으면 다음 컴퍼넌트와 속성이 달라질 우려가 있음。
  ircompns = 0
  ircompname = []
  ircompyzahyo = [yzahyo]
  ircompxzahyo = [0]
  irectorents.each {|irent|
    irns = ircompname.index(irent.definition.name)
    if irns == nil then
      ircompname.push irent.definition.name  # 배열은０부터 작성
      yzahyo = ircompyzahyo[ircompns]
      xzahyo = 0
      ircompxzahyo[ircompns] = 0 + irent.bounds.max.x - irent.bounds.min.x + @yadd
      ircompns = ircompns + 1
      ircompyzahyo.push yzahyo + irent.bounds.max.y - irent.bounds.min.y + @yadd
      ircompxzahyo.push 0
    else
      yzahyo = ircompyzahyo[irns]
      xzahyo = ircompxzahyo[irns]
      ircompxzahyo[irns] = xzahyo + irent.bounds.max.x - irent.bounds.min.x + @yadd
# UI.messagebox(irent.definition.name + " " + xzahyo.to_s + " "  + " " + yzahyo.to_s )
    end
    transpt = Geom::Point3d.new xzahyo, yzahyo, 0
    enttrans( irent , transpt )
    if textnamesw == 1 then
      if irns == nil then
        textpoint = Geom::Point3d.new irent.bounds.min.x , ( irent.bounds.max.y + irent.bounds.min.y ) / 2 , ( irent.bounds.max.z + irent.bounds.min.z ) / 2
        enttext = entities.add_text irent.definition.name , textpoint , @textarrowvector
      end
    end
  }

#  시점(뷰)변경
  Sketchup.send_action("viewTop:")
  Sketchup.send_action("viewZoomExtents:")

#  메시지
  Sketchup::set_status_text("group 1 line, please wait......Done.", SB_PROMPT) 
  UI.messagebox("종료했습니다。" +
                "선이(" + nr_edges.to_s + ")값이거나 면이(" + nr_faces.to_s + ")값일 경우는 이동할수 없습니다。" +
                "사이즈가(" + nr_dimensions.to_s + ")인 자료는 삭제됩니다。hongmidi(홍사철)" ) 

  Sketchup.active_model.commit_operation

end #of def

#============= 달리 설정값을 주지 않으면 설정당시의 각도로 회전합니다 =============
def rotateorigin( e )

  transorigin = e.transformation.clone
#  사이즈를 변경하지 않거나x,y,z순으로 체크한다。
  vectorkijyun = Geom::Vector3d.new 1,0,0
  transvector = vectorkijyun.transform! transorigin
  sabun = transvector.length - 1
  if sabun.abs < 0.000001 then
    vectorkijyun = Geom::Vector3d.new 0,1,0
    transvector = vectorkijyun.transform! transorigin
    sabun = transvector.length - 1
    if sabun.abs < 0.000001 then
      vectorkijyun = Geom::Vector3d.new 0,0,1
      transvector = vectorkijyun.transform! transorigin
      sabun = transvector.length - 1
      if sabun.abs < 0.000001 then
        e.transform!(transorigin.inverse)
      end
    end
  end

end

#============= 객체 각변의 길이가 Ｘ、Ｙ、Ｚ의 순이 되도록 90도 회전한다 =============
def rotate90( e )
  eboundx = e.bounds.max.x - e.bounds.min.x
  eboundy = e.bounds.max.y - e.bounds.min.y
  eboundz = e.bounds.max.z - e.bounds.min.z
#        
  if eboundz > eboundy and eboundz > eboundx then
    trti = Geom::Transformation.rotation(e.bounds.min, [0, 1, 0] , 90.degrees)
  	e.transform!(trti)
#   	e.name = e.name + ",Y+90"
   	if eboundx > eboundy then
      trti = Geom::Transformation.rotation(e.bounds.min, [1, 0, 0] , 90.degrees)
     	e.transform!(trti)
#     	e.name = e.name + ",X+90"
    end
  elsif eboundy > eboundx and eboundy > eboundz then
    trti = Geom::Transformation.rotation(e.bounds.min, [0, 0, 1] , 90.degrees)
    e.transform!(trti)
#   	e.name = e.name + ",Z+90"
 	  if eboundz > eboundx then
	    trti = Geom::Transformation.rotation(e.bounds.min, [1, 0, 0] , 90.degrees)
      e.transform!(trti)
#     	e.name = e.name + ",X+90"
    end
  elsif eboundz > eboundy then
    trti = Geom::Transformation.rotation(e.bounds.min, [1, 0, 0] , 90.degrees)
    e.transform!(trti)
#   	e.name = e.name + ",X+90"
  end

end

#============= 객체 왼쪽아래 자표를 설정한 좌표로 평행 이동한다 =============
def enttrans( e , transpt )

  trvec = Geom::Vector3d.new(transpt-e.bounds.min)
  trts = Geom::Transformation.translation(trvec)
  e.transform!(trts)

end

#============= 객체의 이름과 사이즈를 Text로 표시한다 =============
def textwrite( e , entities , textnamesw )

 # 그룹명이나 레이어명
  textpoint = Geom::Point3d.new e.bounds.min.x , ( e.bounds.max.y + e.bounds.min.y ) / 2 , ( e.bounds.max.z + e.bounds.min.z ) / 2
  if textnamesw == 1 then
	  enttext = entities.add_text e.name , textpoint , @textarrowvector
	else
	  enttext = entities.add_text e.layer.name , textpoint , @textarrowvector
	end
  enttext.leader_type = 1

 # 그룹사이즈
  textpoint = Geom::Point3d.new e.bounds.max.x , ( e.bounds.max.y + e.bounds.min.y ) / 2 , ( e.bounds.max.z + e.bounds.min.z ) / 2
  enttext = entities.add_text e.bounds.width.to_l.to_s + "×" + e.bounds.height.to_l.to_s + "×" +e.bounds.depth.to_l.to_s , textpoint , @textarrowvectorsize
  enttext.leader_type = 1

end

#=============================================================================
# Add a menu 
if( not $ozlineup_menu_loaded )
  add_separator_to_menu("Tools")
  ozlineup_menu = UI.menu("Tools").add_item("부재나열") { ozlineup }
  $ozlineup_menu_loaded = true
end
