# OZReport.rb http://www.est.hi-ho.ne.jp/atamadekkati/ 
# 그룹화 컴퍼넌트화 되어진 재료의 길이 깊히 높이의 일람표를 작성。
# 2013/06/03 한글화 편집및 작성: hongmidi홍사철
# 2009/11/05 ver1.10 ver7용 수정
#
# 책임은 사용자 스스로져야 합니다。
# 내용변경으로 개선될수 있다면 알려 주시길...。
#
# windows등에서 일본어의 sjis파일명을 사용할 경우는 uconv.so를 입수하여 플러그인 폴더에 넣고、
# 「#uconv」라고 되어있는 3군데를 공백으로 치환해서 그 3행을 Comment에서는 삭제하는것이 바람직함。
# 수정한 파일을 보관할때는 UTF-8N으로 보관해야만 하므로 windows메모장으로는 무리..。

require 'sketchup.rb'
#uconv  require 'uconv'  #ruby(http://www.ruby-lang.org/ja/)에 표준으로 들어가 있는듯 함。
#uconv  $KCODE = 'UTF8'  #sketchup상에서는 UTF8이 표준인듯 하므로..。

def ozreport
#  버전 체크
  version_required = 6.0 
  if (Sketchup.version.to_f < version_required)  
    UI.messagebox("You must have Sketchup " + version_required.to_s + 
                  " to run this plugin. Visit sketchup.google.com to upgrade.") 
    return 
  end

  model = Sketchup.active_model
  entities = model.entities
  mpath = model.path
  if mpath == ""
    UI.messagebox "이 파일의 보관 폴더에 일람파일이 출력되니 사전에 무재(제목없음)을 Save할것。"
    return nil
  end
  model_filename = mpath.split("\\")
  model_filename = model_filename[model_filename.length-1].split(".")[0]
  bbox = model.bounds

#　파일명 설정과 파일형식(separator)의 설정
  f_name = model_filename + "_group_report.html"
  $stline = "<tr><td>"
  $sep = '</td><td>'
  $endline = '</td></tr>'

  Sketchup::set_status_text("Gathering information, please wait...", SB_PROMPT) 

#　파일작성(에러핸들을 만들지않는 강제 덮어쓰기)
#uconv  f_name=Uconv.u8tosjis(f_name)   #파일명을UTF-8에서shift-JIS로 변환한다。
   output = File.new(f_name , "w" )
#  html해더일부
  output.puts("<html>")
  output.puts('<head><META http-equiv=Content-Type content="text/html; charset=utf-8"></head>')
  output.puts("<body>")

#  html파일 해더부의 파일개요
  output.puts("<table>")
  output.puts($stline + "파일명" +  $sep + File.basename(model.path) + $endline)
  output.puts($stline + "entities갯수" +  $sep + entities.length.to_s + $endline)
  output.puts("</table>")

  output.puts("<table>")
  output.puts($stline + "도형범위폭" + $sep + bbox.width.to_l.to_s + $endline)
  output.puts($stline + "도형범위깊이" + $sep + bbox.height.to_l.to_s + $endline)
  output.puts($stline + "도형범위높이" + $sep + bbox.depth.to_l.to_s + $endline)
  output.puts("</table>")
  
# 속성처리
  nr_edges = nr_faces = nr_componentinstances = nr_groups = nr_images = nr_sectionplanes = nr_dimensions = nr_texts = nr_clines = nr_cpoints = 0
  output.puts("<table>")
  output.puts($stline + "타입" + $sep + "레이어명" + $sep + "명칭" + $sep + "전체폭" + $sep + "전체깊이" + $sep + "전체높이" + $sep \
                      + "정의명" + $sep + "정의폭" + $sep + "정의깊이" + $sep + "정의높이" + $endline)
  entities.each {|e|
    type = e.typename
    case type
      when "Edge"
        nr_edges = nr_edges + 1
      when "Face"
        nr_faces = nr_faces + 1

#   Component만들기
      when "ComponentInstance"
        nr_componentinstances = nr_componentinstances + 1
        output.puts($stline + "component" + $sep + e.layer.name.to_s + $sep + e.name.to_s + $sep + e.bounds.width.to_l.to_s + $sep + e.bounds.height.to_l.to_s + $sep + e.bounds.depth.to_l.to_s + $sep \
                   + e.definition.name.to_s + $sep + e.definition.bounds.width.to_l.to_s + $sep + e.definition.bounds.height.to_l.to_s + $sep + e.definition.bounds.depth.to_l.to_s + $endline)

#   group만들기
      when "Group"
        nr_groups = nr_groups + 1
        if (Sketchup.version.to_f >= 7.0)  
          output.puts($stline + "group" + $sep + e.layer.name.to_s + $sep + e.name.to_s + $sep + e.bounds.width.to_l.to_s + $sep + e.bounds.height.to_l.to_s + $sep + e.bounds.depth.to_l.to_s + $sep \
                   + "group초기치" + e.local_bounds.width.to_l.to_s + $sep + e.local_bounds.height.to_l.to_s + $sep + e.local_bounds.depth.to_l.to_s + $endline )
        else
          output.puts($stline + "group" + $sep + e.layer.name.to_s + $sep + e.name.to_s + $sep + e.bounds.width.to_l.to_s + $sep + e.bounds.height.to_l.to_s + $sep + e.bounds.depth.to_l.to_s + $sep \
                   + "" + $sep + "" + $sep + "" + $sep + "" + $endline )
        end

      when "Image"
        nr_images = nr_images + 1
      when "SectionPlane"
        nr_sectionplanes = nr_sectionplanes + 1
      when "DimensionLinear" 
        nr_dimensions = nr_dimensions + 1
      when "DimensionRadial" 
        nr_dimensions = nr_dimensions + 1
      when "Text"
        nr_texts = nr_texts + 1
      when "ConstructionLine"
        nr_clines = nr_clines + 1
      when "ConstructionPoint"
        nr_cpoints = nr_cpoints + 1
    end
  }
  output.puts("</table>")

# 속성정보만들기
  output.puts("<table>")
  output.puts($stline + "Edges" + $sep + nr_edges.to_s + $endline)
  output.puts($stline + "Faces " + $sep + nr_faces.to_s + $endline)
  output.puts($stline + "Components" + $sep + nr_componentinstances.to_s + $endline)
  output.puts($stline + "Groups" + $sep + nr_groups.to_s + $endline)
  output.puts($stline + "Images" + $sep + nr_images.to_s + $endline)
  output.puts($stline + "Section_planes" + $sep + nr_sectionplanes.to_s + $endline)
  output.puts($stline + "Dimensions" + $sep + nr_dimensions.to_s + $endline)
  output.puts($stline + "Texts" + $sep + nr_texts.to_s + $endline)
  output.puts($stline + "Construction lines" + $sep + nr_clines.to_s + $endline)
  output.puts($stline + "Construction points" + $sep + nr_cpoints.to_s + $endline)
  output.puts("</table>")
  
#　파일 Close만들기
  output.puts("</body>")
  output.puts("</html>")
  output.close

#  메시지
  Sketchup::set_status_text("Gathering information, please wait...Done.", SB_PROMPT) 
  UI.messagebox "파일을 작성하였습니다。hongmidi(홍사철)" 
end #of def

#=============================================================================
# Add a menu 
if( not $ozreport_menu_loaded )
  add_separator_to_menu("Tools")
  ozreport_menu = UI.menu("Tools").add_item("부재일람html") { ozreport }
  $ozreport_menu_loaded = true
end
